--[[
************************************************************************
Project				: Broker_HitCrit
Author				: zhinjio
Project Revision	: 1.5-release
Project Date		: 20090530042148

File				: Broker_HitCrit.lua
Commit Author		: zhinjio
Commit Revision		: 14
Commit Date			: 20081106090019
************************************************************************
Description	:
	Main addon file. 

TODO		:
	Figure out sound notify
	Figure out notify area notify

************************************************************************
(see bottom of file for changelog)
************************************************************************
--]]

-- For now, we need a hack in here to make sure ace3 loads before I do.
-- All hail disembeded libraries and their swift return....
LoadAddOn("Ace3")

HitCrit_VERSION = 0.1
HitCrit_DEBUG = false
-- HitCrit_DEBUG = true

local HitCrit = LibStub( "AceAddon-3.0" ):NewAddon( "HitCrit", "AceEvent-3.0" )
local L = LibStub:GetLibrary( "AceLocale-3.0" ):GetLocale( "HitCrit" )
local AceConfig 		= LibStub("AceConfig-3.0")
local AceConfigReg 		= LibStub("AceConfigRegistry-3.0")
local AceConfigDialog 	= LibStub("AceConfigDialog-3.0")

local addonversion = "1.5-release"
local addonauthor = "zhinjio"
local builddate = "20090530042148"

_G["HitCrit"] = HitCrit
addon = HitCrit

local MODNAME = "HitCrit"
local modularOptions = {}
local tooltip
local LTT = LibStub:GetLibrary( "LibTooltip-1.0" )

local db
local spellSchools = {
	[1]		= L["physical"],	-- 0x01	1	physical
	[2]		= L["holy"],		-- 0x02	2	holy
	[4]		= L["fire"],		-- 0x04	4	fire
	[8]		= L["nature"],		-- 0x08	8	nature
	[16]	= L["frost"],		-- 0x10	16	frost
	[20]	= L["frostfire"],	-- 0x18	20	frostfire
	[24]	= L["froststorm"],	-- 0x14	24	froststorm
	[32]	= L["shadow"],		-- 0x20	32	shadow
	[40]	= L["shadowstorm"],	-- 0x28	40	shadowstorm
	[64]	= L["arcane"],		-- 0x40	64	arcane
}

function HitCrit_Print( msg )
	local _, fh = DEFAULT_CHAT_FRAME:GetFont()
	fh = math.ceil( fh )
	local icon = "\124TInterface\\Addons\\Broker_HitCrit\\icon:" .. fh .. "\124t"
	if ( msg ~= nil ) then
	   if( DEFAULT_CHAT_FRAME ) then
	      DEFAULT_CHAT_FRAME:AddMessage( icon .. " HitCrit: " .. msg, 0.6, 1.0, 1.0 )
	   end
	end
end

function HitCrit_Debug( msg )
	if ( msg ~= nil ) then
		if ( HitCrit_DEBUG ) then
			HitCrit_Print( "DEBUG: " .. msg )
		end
	end
end

function HitCrit_Red( text )
	return "|cffff0000" .. text .. "|r"
end
function HitCrit_Yellow( text )
	return "|cffffff00" .. text .. "|r"
end
function HitCrit_Green( text )
	return "|cff00ff00" .. text .. "|r"
end
function HitCrit_White( text )
	return "|cffffffff" .. text .. "|r"
end
function HitCrit_hit( text)
	return "|cff00ffff" .. text .. "|r"
end
function HitCrit_crit( text)
	return "|cffff8080" .. text .. "|r"
end
function HitCrit_sch( text)
	return "|cffdfa050" .. text .. "|r"
end

function HitCrit:AlertNew( crit, heal, target, spellName, amount )
	local hType, hStr = L["Hit"], L["hit"]
	if ( heal == 1 ) then
		hStr = L["healed"]
		if ( crit == 1 ) then
			hType = L["Critical Heal"]
		else
			hType = L["Heal"]
		end
	else
		if ( crit == 1 ) then
			hType = L["Critical Hit"]
		end
	end
	if ( db.options.alerts.chatframe == true ) then
		HitCrit_Print( string.format( L["New Record %s! %s %s %s for %d"], hType, spellName, hStr, target, amount ) )
	end
	if ( db.options.alerts.notify == true ) then
		UIErrorsFrame:AddMessage( string.format( L["New Record %s! %s %s %s for %d"], hType, spellName, hStr, target, amount ) )
		-- Still need to figure this out
	end
	if ( db.options.alerts.sound == true ) then
		-- Still need to figure this out
		PlaySound("LEVELUPSOUND")
	end
end

function HitCrit_initHC( entry )
	entry.hit = {}; entry.crit = {}
	entry.total = 0
	entry.num = 0
	for i = 1, 3 do
		entry.hit[i] = {}
		entry.hit[i].value = 0
		entry.hit[i].name = ""
		entry.crit[i] = {}
		entry.crit[i].value = 0
		entry.crit[i].name = ""
	end
end

function HitCrit_initSpellEntry()
	local entry = {}
	entry.effect = ""
	entry.school = 0
	entry.rank = 0
	HitCrit_initHC( entry )
	return entry
end

function HitCrit_CheckInsertAlert( heal, id, hit, crit, dName, effect, sch )
	if ( effect ~= "" ) then
		if ( heal == 1 ) then side = "heal" else side = "damage" end
		if ( db.values[side][id] ) then
			local entry = db.values[side][id]
			-- this value already exists. Compare to current, and replace if needed
			if ( crit ~= 0 ) then
				entry.total = entry.total + crit
				entry.num = entry.num + 1
				if ( crit > entry.crit[1].value ) then
					entry.crit[3].value = entry.crit[2].value
					entry.crit[3].name = entry.crit[2].name
					entry.crit[2].value = entry.crit[1].value
					entry.crit[2].name = entry.crit[1].name
					entry.crit[1].value = crit
					entry.crit[1].name = dName
					HitCrit:AlertNew( 1, heal, dName, effect, crit )
				elseif ( crit > entry.crit[2].value ) then
					entry.crit[3].value = entry.crit[2].value
					entry.crit[3].name = entry.crit[2].name
					entry.crit[2].value = crit
					entry.crit[2].name = dName
				elseif ( crit > entry.crit[3].value ) then
					entry.crit[3].value = crit
					entry.crit[3].name = dName
				end
			else
				entry.total = entry.total + hit
				entry.num = entry.num + 1
				if ( hit > entry.hit[1].value ) then
					entry.hit[3].value = entry.hit[2].value
					entry.hit[3].name = entry.hit[2].name
					entry.hit[2].value = entry.hit[1].value
					entry.hit[2].name = entry.hit[1].name
					entry.hit[1].value = hit
					entry.hit[1].name = dName
					HitCrit:AlertNew( 1, heal, dName, effect, hit )
				elseif ( hit > entry.hit[2].value ) then
					entry.hit[3].value = entry.hit[2].value
					entry.hit[3].name = entry.hit[2].name
					entry.hit[2].value = hit
					entry.hit[2].name = dName
				elseif ( hit > entry.hit[3].value ) then
					entry.hit[3].value = hit
					entry.hit[3].name = dName
				end
			end
		else
			-- This could be a previously tracked spell, just with a new rank
			local sName, sRank = GetSpellInfo( id )
			local prevSpellID = 0
			if ( id ~= 0 ) then
				-- sName should match "effect" I believe 
				if ( sName ~= effect ) then HitCrit_Debug( "Spell name (" .. sName .. ") did not match effect (" .. effect ")" ) end
				for k, v in pairs( db.values[side] ) do
					if ( v.effect == sName ) then
						if ( sRank ~= v.rank ) then
							prevSpellID = k
							HitCrit_Debug( "h/id/hit/crit/nm/eff/sch = "..heal.."/"..id.."/"..hit.."/"..crit.."/"..dName.."/"..effect.."/"..sch )
							HitCrit_Debug( "side/sName/rank = "..side.."/"..sName.."/"..sRank )
							break
						else
							-- if we're here, someone is casting a downranked spell. Nub.
						end
					end
				end
			end
			if ( prevSpellID ~= 0 ) then
				-- nuke old data
				db.values[side][prevSpellID] = nil
			end

			-- Otherwise, we've got a new previously untracked value. Record all the info
			db.values[side][id] = {}
			local entry = HitCrit_initSpellEntry()
			entry.effect = effect
			entry.school = sch
			entry.rank = sRank
			entry.hit[1].value = hit
			entry.crit[1].value = crit
			if ( crit ~= 0 ) then
				entry.total = crit
				entry.num = 1
				entry.crit[1].name = dName
				HitCrit:AlertNew( 1, heal, dName, effect, crit )
			else
				entry.total = hit
				entry.num = 1
				entry.hit[1].name = dName
				HitCrit:AlertNew( 0, heal, dName, effect, hit )
			end
			db.values[side][id] = entry
		end
	end
end

function HitCrit:COMBAT_LOG_EVENT_UNFILTERED( _, _, eType, sGUID, sName, sFlags, dGUID, dName, dFlags, ... )
-- Parameters:
--	event		COMBAT_LOG_EVENT_UNFILTERED
--	timestamp
--	eType		event type (for example, SPELL_DAMAGE)
--	sGUID		source GUID
--	sName		source Name
--	sFlags		source Flags
--	dGUID		destination GUID
--	dName		destination Name
--	dFlags		destination Flags
--
--		The remaining parameters are dependent on eType
--
--		For RANGE_, SPELL_, SPELL_AURA_ and SPELL_PERIODIC_ prefixes, you have the following
--			spellId
--			spellName
--			spellSchool
--
--		Then, for _DAMAGE suffixes:
--			amount
--			overkill
--			school
--			resisted
--			blocked
--			absorbed
--			critical (1 or nil)
--			glancing (1 or nil)
--			crushing (1 or nil)
--
--		Then, for _HEAL suffixes:
--			amount
--			overhealing
--			critical
--
	local effect, id, hit, crit, sch, heal = "", 0, 0, 0, 0, 0
	if ( sGUID == HitCrit.GUID ) then
		-- First, check for damage
		if ( db.options.tracking.damage ) then
			if ( eType == "SWING_DAMAGE" ) then
				local amount, _, school, resisted, blocked, absorbed, critical, glance, crush = select( 1, ... )
				id = 0; effect = L["Melee"]; sch = school
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "RANGE_DAMAGE" ) then
				local spellID, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glance, crush = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_DAMAGE" ) then
				local spellID, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glance, crush = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_AURA_DAMAGE" ) then
				-- does this event exist?
				local spellID, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glance, crush = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_PERIODIC_DAMAGE" ) then
				local spellID, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, crit, glance, crush = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			end
		end
		if ( db.options.tracking.healing ) then
			if ( eType == "SWING_HEAL" ) then
				-- does this event exist?
				local amount, overheal, crit = select( 1, ... )
				id = 0; effect = L["Melee"]; sch = 1; heal = 1
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "RANGE_HEAL" ) then
				-- does this event exist?
				local spellID, spellName, spellSchool, amount, overheal, critical = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool; heal = 1
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_HEAL" ) then
				local spellID, spellName, spellSchool, amount, overheal, critical = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool; heal = 1
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_AURA_HEAL" ) then
				-- does this event exist?
				local spellID, spellName, spellSchool, amount, overheal, critical = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool; heal = 1
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_PERIODIC_HEAL" ) then
				local spellID, spellName, spellSchool, amount, overheal, critical = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool; heal = 1
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			end
		end
	elseif ( ( db.options.tracking.againstMe == true ) and ( dGUID == HitCrit.GUID ) ) then
	end
	HitCrit_CheckInsertAlert( heal, id, hit, crit, dName, effect, sch )
end

local LDB = LibStub( "LibDataBroker-1.1" )
local launcher = LDB:NewDataObject( "HitCrit", {
	type = "launcher",
	text = "HitCrit",
	label = "Broker_HitCrit",
	icon = "Interface\\Addons\\Broker_HitCrit\\icon",
	OnClick = function(clickedframe, button) HitCrit:ShowConfig() end,
	OnEnter = function ( self )
		tooltip:Clear()
		local t = {}
		t[1] = 3
		t[2] = "LEFT"
		if ( db.options.display.avg ) then t[1] = t[1] + 2; table.insert( t, "CENTER" ); table.insert( t, "RIGHT" ) end
		if ( db.options.display.hit ) then t[1] = t[1] + 2; table.insert( t, "CENTER" ); table.insert( t, "RIGHT" ) end
		if ( db.options.display.crit ) then t[1] = t[1] + 2; table.insert( t, "CENTER" ); table.insert( t, "RIGHT" ) end
		if ( db.options.display.enemyName ) then t[1] = t[1] + 2; table.insert( t, "CENTER" ); table.insert( t, "RIGHT" ) end
		tooltip:SetColumnLayout( unpack( t ) )

		local myFont = CreateFont("MyFont")
		if ( db.options.display.fontsize == "small" ) then
			myFont:CopyFontObject(SystemFont_Tiny)
			tooltip:SetFont(myFont)
			myFont:CopyFontObject(SystemFont_Med1)
			tooltip:SetHeaderFont(myFont)
		else
			myFont:CopyFontObject(SystemFont_Small)
			tooltip:SetFont(myFont)
			myFont:CopyFontObject(SystemFont_Med2)
			tooltip:SetHeaderFont(myFont)
		end
		tooltip:AddHeader( HitCrit_White( L["Broker_HitCrit"] ) )

		local t = {}
		if ( db.options.display.type ) then
			-- sort by damage school
			local schools = {}; schools.damage = {}; schools.healing = {}
			for k, v in pairs( spellSchools ) do schools.damage[k] = {}; schools.healing[k] = {} end
			for k, v in pairs( db.values["damage"] ) do
				schools.damage[v.school][k] = true
			end
			for k, v in pairs( db.values["heal"] ) do
				schools.healing[v.school][k] = true
			end
			-- damage block
			tooltip:AddLine( HitCrit_Red( "  " .. L["Damage"] ) )
			t = {}
			table.insert( t, HitCrit_White( "    " .. L["Effect"] ) )
			if ( db.options.display.avg ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Avg"] ) ) end
			if ( db.options.display.hit ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Hit"] ) ) end
			if ( db.options.display.crit ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Crit"] ) ) end
			if ( db.options.display.enemyName ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Against"] ) ) end
			tooltip:AddLine( unpack( t ) )
			for k, v in pairs( spellSchools ) do
				if ( next( schools.damage[k] ) ~= nil ) then
					tooltip:AddLine( HitCrit_sch( "    " .. v ) )
					for m, u in pairs( schools.damage[k] ) do
						local i = db.values["damage"][m]
						local e, h, c, a = i.effect, i.hit[1].value, i.crit[1].value, floor( i.total / i.num )
						if ( i.num == 0 ) then a = " " end
						t = nil; t = {}
						table.insert( t, HitCrit_Yellow( "      " .. e ) )
						if ( db.options.display.avg ) then table.insert( t, " " ); table.insert( t, HitCrit_Yellow( a ) ) end
						if ( db.options.display.hit ) then table.insert( t, " " ); table.insert( t, HitCrit_hit( h ) ) end
						if ( db.options.display.crit ) then table.insert( t, " " ); table.insert( t, HitCrit_crit( c ) ) end
						if ( db.options.display.enemyName ) then 
							if ( c ~= 0 ) then
								table.insert( t, " " ); table.insert( t, HitCrit_crit( i.crit[1].name ) )
							else
								table.insert( t, " " ); table.insert( t, HitCrit_hit( i.hit[1].name ) )
							end
						end
						tooltip:AddLine( unpack( t ) )
					end
				end
			end
			-- healing block
			tooltip:AddLine( HitCrit_Green( "  " .. L["Healing"] ) )
			t = {}
			table.insert( t, HitCrit_White( "    " .. L["Effect"] ) )
			if ( db.options.display.avg ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Avg"] ) ) end
			if ( db.options.display.hit ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Hit"] ) ) end
			if ( db.options.display.crit ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Crit"] ) ) end
			if ( db.options.display.enemyName ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Against"] ) ) end
			tooltip:AddLine( unpack( t ) )
			for k, v in pairs( spellSchools ) do
				if ( next( schools.healing[k] ) ~= nil ) then
					tooltip:AddLine( HitCrit_sch( "    " .. v ) )
					for m, n in pairs( schools.healing[k] ) do
						local i = db.values["heal"][m]
						local e, h, c, a = i.effect, i.hit[1].value, i.crit[1].value, floor( i.total / i.num )
						if ( i.num == 0 ) then a = " " end
						t = nil; t = {}
						table.insert( t, HitCrit_Yellow( "      " .. e ) )
						if ( db.options.display.avg ) then table.insert( t, " " ); table.insert( t, HitCrit_Yellow( a ) ) end
						if ( db.options.display.hit ) then table.insert( t, " " ); table.insert( t, HitCrit_hit( h ) ) end
						if ( db.options.display.crit ) then table.insert( t, " " ); table.insert( t, HitCrit_crit( c ) ) end
						if ( db.options.display.enemyName ) then 
							if ( c ~= 0 ) then
								table.insert( t, " " ); table.insert( t, HitCrit_crit( i.crit[1].name ) )
							else
								table.insert( t, " " ); table.insert( t, HitCrit_hit( i.hit[1].name ) )
							end
						end
						tooltip:AddLine( unpack( t ) )
					end
				end
			end
		else
			-- damage header lines
			tooltip:AddLine( HitCrit_Red( "  " .. L["Damage"] ) )
			table.insert( t, HitCrit_White( "    " .. L["Effect"] ) )
			if ( db.options.display.avg ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Avg"] ) ) end
			if ( db.options.display.hit ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Hit"] ) ) end
			if ( db.options.display.crit ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Crit"] ) ) end
			if ( db.options.display.enemyName ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Against"] ) ) end
			tooltip:AddLine( unpack( t ) )
			-- loop through damage
			for k, v in pairs( db.values["damage"] ) do
				local e, h, c, a = v.effect, v.hit[1].value, v.crit[1].value, floor( v.total / v.num )
				if ( v.num == 0 ) then a = " " end
				t = nil; t = {}
				table.insert( t, HitCrit_Yellow( "    " .. e ) )
				if ( db.options.display.avg ) then table.insert( t, " " ); table.insert( t, HitCrit_Yellow( a ) ) end
				if ( db.options.display.hit ) then table.insert( t, " " ); table.insert( t, HitCrit_hit( h ) ) end
				if ( db.options.display.crit ) then table.insert( t, " " ); table.insert( t, HitCrit_crit( c ) ) end
				if ( db.options.display.enemyName ) then 
					if ( c ~= 0 ) then
						table.insert( t, " " ); table.insert( t, HitCrit_crit( v.crit[1].name ) )
					else
						table.insert( t, " " ); table.insert( t, HitCrit_hit( v.hit[1].name ) )
					end
				end
				tooltip:AddLine( unpack( t ) ) 
			end
			-- healing header lines
			tooltip:AddLine( HitCrit_Green( "  " .. L["Healing"] ) )
			t = nil; t = {}
			table.insert( t, HitCrit_White( "    " .. L["Effect"] ) )
			if ( db.options.display.avg ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Avg"] ) ) end
			if ( db.options.display.hit ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Hit"] ) ) end
			if ( db.options.display.crit ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Crit"] ) ) end
			if ( db.options.display.enemyName ) then table.insert( t, " " ); table.insert( t, HitCrit_White( L["Against"] ) ) end
			tooltip:AddLine( unpack( t ) )
			-- loop through healing
			for k, v in pairs( db.values["heal"] ) do
				local e, h, c, a = v.effect, v.hit[1].value, v.crit[1].value, floor( v.total / v.num )
				if ( v.num == 0 ) then a = " " end
				t = nil; t = {}
				table.insert( t, HitCrit_Yellow( "    " .. e ) )
				if ( db.options.display.avg ) then table.insert( t, " " ); table.insert( t, HitCrit_Yellow( a ) ) end
				if ( db.options.display.hit ) then table.insert( t, " " ); table.insert( t, HitCrit_hit( h ) ) end
				if ( db.options.display.crit ) then table.insert( t, " " ); table.insert( t, HitCrit_crit( c ) ) end
				if ( db.options.display.enemyName ) then 
					if ( c ~= 0 ) then
						table.insert( t, " " ); table.insert( t, HitCrit_crit( v.crit[1].name ) )
					else
						table.insert( t, " " ); table.insert( t, HitCrit_hit( v.hit[1].name ) )
					end
				end
				tooltip:AddLine( unpack( t ) ) 
			end
		end
		tooltip:SmartAnchorTo( self )
		tooltip:Show()
	end,
	OnLeave = function ( )
		tooltip:Hide()
	end,
} )

function HitCrit_upgradeDB()
	local olddb = HitCrit.db.factionrealm[HitCrit.me]
	-- This checks the current DB version the person has, and upgrades as necessary
	if not ( olddb.options.display.dbVersion ) then
		-- They have the original version
		local values = {}; values["damage"] = {}; values["heal"] = {}
		local side = "damage"
		for k, v in pairs( olddb.values ) do
			HitCrit_Debug( "id/h/c/dmg/sch/eff = "..k.."/"..v.hit.."/"..v.crit.."/"..
				v.dmg.."/"..v.school.."/"..v.effect )
			if ( v.dmg == 1 ) then side = "damage" else side = "heal" end
			local entry = HitCrit_initSpellEntry()
			_, sRank = GetSpellInfo( k )
			entry.school = v.school
			entry.effect = v.effect
			entry.rank = sRank
			entry.total = 0
			entry.num = 0
			entry.hit[1].value = v.hit
			entry.crit[1].value = v.crit
			if ( v.hit == 0 ) then entry.hit[1].name = "" else entry.hit[1].name = v.target end
			if ( v.crit == 0 ) then entry.crit[1].name = "" else entry.crit[1].name = v.target end
			values[side][k] = entry
		end
		olddb.values = nil
		olddb.values = values
		olddb.options.display.dbVersion = "1.1"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "1.1" ) )
	end
	if ( olddb.options.display.dbVersion == "1.1" ) then
		olddb.options.tracking.lowlevel = false
		olddb.options.display.dbVersion = "1.2"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "1.2" ) )
	end
	if ( olddb.options.display.dbVersion == "1.2" ) then
		olddb.options.display.avg = true
		olddb.options.display.dbVersion = "1.3"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "1.3" ) )
	end
end

local alertOptions = nil
local displayOptions = nil
local trackingOptions = nil

-- options stuff
local function giveTracking()
	if (not trackingOptions) then
		trackingOptions = {
			order = 2,
			type = "group",
			name = L["Tracking Options"],
			desc = L["TRACKING_OPTIONS_DESC"],
			args = {
				header1 = {
					order	= 21,
					type	= "header",
					name	= L["Tracking Options"],
				},
				desc = {
					order	= 22,
					type	= "description",
					name	= L["TRACKING_OPTIONS_DESC"],
				},
				pvp = {
					order	= 23,
					type	= "toggle",
					name	= L["Track PvP"],
					desc	= L["TRACK_PVP_DESC"],
					get		= function() return db.options.tracking.pvp end,
					set		= function() db.options.tracking.pvp = not db.options.tracking.pvp end,
					disabled = true,
				},
				againstMe = {
					order	= 24,
					type	= "toggle",
					name	= L["Track Hits Against Me"],
					desc	= L["TRACK_AGAINSTME_DESC"],
					get		= function() return db.options.tracking.againstMe end,
					set		= function() db.options.tracking.againstMe = not db.options.tracking.againstMe end,
					disabled = true,
				},
				damage = {
					order	= 25,
					type	= "toggle",
					name	= L["Track Damage"],
					desc	= L["TRACK_DAMAGE_DESC"],
					get		= function() return db.options.tracking.damage end,
					set		= function() db.options.tracking.damage = not db.options.tracking.damage end,
				},
				healing = {
					order	= 26,
					type	= "toggle",
					name	= L["Track Healing"],
					desc	= L["TRACK_HEALING_DESC"],
					get		= function() return db.options.tracking.healing end,
					set		= function() db.options.tracking.healing = not db.options.tracking.healing end,
				},
				environmental = {
					order	= 27,
					type	= "toggle",
					name	= L["Track Environmental"],
					desc	= L["TRACK_ENVIRONMENTAL_DESC"],
					get		= function() return db.options.tracking.environmental end,
					set		= function() db.options.tracking.environmental = not db.options.tracking.environmental end,
					disabled = true,
				},
				vulnerable = {
					order	= 28,
					type	= "toggle",
					name	= L["Track Vulnerable"],
					desc	= L["TRACK_VULNERABLE_DESC"],
					get		= function() return db.options.tracking.vulnerable end,
					set		= function() db.options.tracking.vulnerable = not db.options.tracking.vulnerable end,
					disabled = true,
				},
				lowlevel = {
					order	= 28,
					type	= "toggle",
					name	= L["Track Low Level"],
					desc	= L["TRACK_LOWLEVEL_DESC"],
					get		= function() return db.options.tracking.lowlevel end,
					set		= function() db.options.tracking.lowlevel = not db.options.tracking.lowlevel end,
					disabled = true,
				},
			},
		}
	end
	return trackingOptions
end

local function giveDisplay()
	if (not displayOptions) then
		displayOptions = {
			order = 3,
			type = "group",
			name = L["Display Options"],
			desc = L["DISPLAY_OPTIONS_DESC"],
			args = {
				header1 = {
					order	= 31,
					type	= "header",
					name	= L["Display Options"],
				},
				desc = {
					order	= 32,
					type	= "description",
					name	= L["DISPLAY_OPTIONS_DESC"],
				},
				avg = {
					order	= 33,
					type	= "toggle",
					name	= L["Display Avg"],
					desc	= L["DISPLAY_AVG_DESC"],
					get		= function() return db.options.display.avg end,
					set		= function() db.options.display.avg = not db.options.display.avg end,
				},
				hit = {
					order	= 34,
					type	= "toggle",
					name	= L["Display Hit"],
					desc	= L["DISPLAY_HIT_DESC"],
					get		= function() return db.options.display.hit end,
					set		= function() db.options.display.hit = not db.options.display.hit end,
				},
				crit = {
					order	= 35,
					type	= "toggle",
					name	= L["Display Crit"],
					desc	= L["DISPLAY_CRIT_DESC"],
					get		= function() return db.options.display.crit end,
					set		= function() db.options.display.crit = not db.options.display.crit end,
				},
				enemyName = {
					order	= 36,
					type	= "toggle",
					name	= L["Display Enemy Name"],
					desc	= L["DISPLAY_ENEMYNAME_DESC"],
					get		= function() return db.options.display.enemyName end,
					set		= function() db.options.display.enemyName = not db.options.display.enemyName end,
				},
				school = {
					order	= 37,
					type	= "toggle",
					name	= L["Sort by School"],
					desc	= L["DISPLAY_SORTSCHOOL_DESC"],
					get		= function() return db.options.display.type end,
					set		= function() db.options.display.type = not db.options.display.type end,
				},
				fontsize = {
					order	= 38,
					type	= "select",
					name	= L["Font Size"],
					desc	= L["DISPLAY_FONTSIZE_DESC"],
					get		= function() return db.options.display.fontsize end,
					set		= function( info, name ) db.options.display.fontsize = name end,
					values	= function() return { Small = L["small"], Large = L["large"] } end
				},
			},
		}
	end
	return displayOptions
end

local function giveAlert()
	if (not alertOptions) then
		alertOptions = {
			order = 4,
			type = "group",
			name = L["Alert Options"],
			desc = L["ALERT_OPTIONS_DESC"],
			args = {
				header1 = {
					order	= 41,
					type	= "header",
					name	= L["Alert Options"],
				},
				desc = {
					order	= 42,
					type	= "description",
					name	= L["ALERT_OPTIONS_DESC"],
				},
				sound = {
					order	= 43,
					type	= "toggle",
					name	= L["Alert with Sound"],
					desc	= L["ALERT_SOUND_DESC"],
					get		= function() return db.options.alerts.sound end,
					set		= function() db.options.alerts.sound = not db.options.alerts.sound end,
				},
				notify = {
					order	= 44,
					type	= "toggle",
					name	= L["Alert with Notify"],
					desc	= L["ALERT_NOTIFY_DESC"],
					get		= function() return db.options.alerts.notify end,
					set		= function() db.options.alerts.notify = not db.options.alerts.notify end,
				},
				chatframe = {
					order	= 45,
					type	= "toggle",
					name	= L["Alert in Chat Frame"],
					desc	= L["ALERT_CHATFRAME_DESC"],
					get		= function() return db.options.alerts.chatframe end,
					set		= function() db.options.alerts.chatframe = not db.options.alerts.chatframe end,
				},
			},
		}
	end
	return alertOptions
end

local options = nil
local function fullOptions()
	if (not options) then
		options = {
			type = "group",
			name = MODNAME,
			args = {
				general = {
					order	= 1,
					type	= "group",
					name	= L["General Information"],
					desc	= L["GENERAL_INFO_DESC"],
					args	= {
						header1 = {
							order	= 11,
							type	= "header",
							name	= L["General Information"],
						},
						desc = {
							order	= 12,
							type	= "description",
							name	= L["GENERAL_INFO_DESC"],
						},
						author = {
							order	= 13,
							type	= "description",
							name	= L["Author : "] .. addonauthor .. "\n",
						},
						version = {
							order	= 14,
							type	= "description",
							name	= L["Version : "] .. addonversion .. "\n",
						},
						builddate = {
							order	= 15,
							type	= "description",
							name	= L["Build Date : "] .. addonauthor .. "\n",
						},
						dbversion = {
							order	= 15,
							type	= "description",
							name	= L["Database Version : "] .. db.options.display.dbVersion .. "\n",
						},
					},
				},
			},
		}
	end
	
	for k,v in pairs(modularOptions) do
		options.args[k] = (type(v) == "function") and v() or v
	end

	return options
end

function addon:SetupOptions()
	AceConfigReg:RegisterOptionsTable(MODNAME, fullOptions)
	self.optionsFrame = AceConfigDialog:AddToBlizOptions(MODNAME, nil, nil, "general")

	-- Fill up our modular options...
	self:RegisterModuleOptions("Tracking", giveTracking(), L["Tracking Options"])
	self:RegisterModuleOptions("Display", giveDisplay(), L["Display Options"])
	self:RegisterModuleOptions("Alert", giveAlert(), L["Alert Options"])
end

function addon:RegisterModuleOptions(name, optionsTable, displayName)
	modularOptions[name] = optionsTable
	self.optionsFrame[name] = AceConfigDialog:AddToBlizOptions(MODNAME, displayName, MODNAME, name)
end

function HitCrit:ShowConfig()
	-- Open the profiles tab before, so the menu expands
	InterfaceOptionsFrame_OpenToCategory( self.optionsFrame["Display"] )
end

-- on init
function HitCrit:OnInitialize()
    -- Called when the addon is loaded
	HitCrit.me = UnitName( "player" )
	HitCrit.GUID = UnitGUID( "player" )
	HitCrit.level = UnitLevel( "player" )

	self.db = LibStub( "AceDB-3.0" ):New( "HitCrit_DB", nil, "Default" )
	-- do we have any data yet; for this toon? If not, init its table
	if not ( self.db.factionrealm[HitCrit.me] ) then
		self.db.factionrealm[HitCrit.me] = {
			options = {
				tracking = {
					pvp = false,
					againstMe = false,
					damage = true,
					healing = true,
					environmental = false,
					vulnerable = false,
					lowlevel = false,
				},
				display = {
					hit = true,
					crit = true,
					avg = true,
					enemyName = false,
					type = false,
					fontsize = "small",
					dbVersion = "1.3",
				},
				alerts = {
					sound = false,
					notify = false,
					chatframe = true,
				},
			},
			values = {
				damage = {},
				heal = {},
			}
		}
	else
		-- check if we need to upgrade the db
		HitCrit_upgradeDB()
	end
	db = self.db.factionrealm[HitCrit.me]

	HitCrit_Debug( "In OnInit" )
	-- Event listeners
    HitCrit:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

	tooltip = LTT:Acquire( "HitCritTT", 7, "LEFT", "CENTER", "RIGHT", "CENTER", "RIGHT", "CENTER", "RIGHT" ) -- or GameTooltip

	HitCrit:SetupOptions()
end

--[[
************************************************************************
CHANGELOG:

Date : 10/29/08
	Initial version
************************************************************************
]]--